###############################################################################
# SeemlySmilies.pm                                                            #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
# Written by Zoo, updated to 2.7.00 by D.A. Rorabaugh (Dandello)              #
###############################################################################
use strict;
use warnings;
no warnings qw(redefine);
use Time::Local;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.7.00';

our $seemlysmiliespmver = 'YaBB 2.7.00 $Revision: 2 $';
our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

our (
    $enable_seemlysmilie, $imagesdir,   $mday,
    $modimgdir,           $modimgurl,   $mon_num,
    $vardir,              $yyhtml_root, %croak
);

my $seemlydirs = qq~$modimgdir/Seemly~;
my $seemlyurl  = qq~$modimgurl/Seemly~;
our $seemlydir = qq~$yyhtml_root/Smilies~;

my @smiliename =
  qw(smiley wink cheesy grin angry sad shocked cool huh rolleyes tongue embarassed lipsrsealed undecided kiss cry);
my $smnum = $#smiliename;

sub seemlyview {
    my ($date) = @_;
    if ($enable_seemlysmilie) {
        our ($FILE);
        fopen( 'FILE', '<', "$vardir/Mods/seemlysmilies.txt" );
        my @seemlysetting = <$FILE>;
        chomp @seemlysetting;
        fclose('FILE');
        my $toffs = toffs($date);
        my $ndate = $toffs + $date;
        my ( $year, $daynum ) = ( gmtime($ndate) )[ 5, 7 ];

        if ( $year % 4 != 0 && $daynum > 59 ) {
            $daynum = $daynum + 1;
        }
        ( $mday, $mon_num ) = ( gmtime($ndate) )[ 3, 4 ];
        my ( $smon, $sday, $sname, $other ) = split /\//xsm,
          $seemlysetting[$daynum];
        my $ok = 0;
        $mon_num += 1;
        if ( $smon == $mon_num && $sday == $mday && $sname ) {
            $ok = 1;
            for my $i ( 0 .. $smnum ) {
                if ( !-e "$seemlydirs/$sname/$smiliename[$i].gif" ) {
                    $ok = 0;
                    last;
                }
            }
        }
        if   ($ok) { $seemlydir = "$seemlyurl/$sname"; }
        else       { $seemlydir = qq~$yyhtml_root/Smilies~; }
    }
    return $seemlydir;
}

sub getseemlyview {
    my ( $message, $mdate ) = @_;
    if ($enable_seemlysmilie) {
        our ($FILE);
        fopen( 'FILE', '<', "$vardir/Mods/seemlysmilies.txt" );
        my @seemlysetting = <$FILE>;
        chomp @seemlysetting;
        fclose('FILE');
        my $toffs = toffs($mdate);
        $mdate += $toffs;
        my ( $year, $daynum ) = ( gmtime($mdate) )[ 5, 7 ];

        if ( $year % 4 != 0 && $daynum > 59 ) {
            $daynum = $daynum + 1;
        }
        ( $mday, $mon_num ) = ( gmtime($mdate) )[ 3, 4 ];
        $mon_num += 1;

        my ( $smon, $sday, $sname, $other ) = split /\//xsm,
          $seemlysetting[$daynum];
        my $ok = 0;
        if ( $smon == $mon_num && $sday == $mday && $sname ) {
            $ok = 1;
            for my $i ( 0 .. $smnum ) {
                if ( !-e "$seemlydirs/$sname/$smiliename[$i].gif" ) {
                    $ok = 0;
                    last;
                }
            }
        }
        if   ($ok) { $seemlydir = "$seemlyurl/$sname"; }
        else       { $seemlydir = qq~$yyhtml_root/Smilies~; }
        for my $i ( 0 .. $smnum ) {
            $message =~
s/src="$yyhtml_root\/Smilies\/$smiliename[$i].gif"/src="$seemlydir\/$smiliename[$i].gif"/gxsm;
        }
    }
    return $message;
}

1;
